import '../utility/log.dart';
import '../utility/scope.dart';

import 'package:flutter/services.dart';

class AttributionAPI {
  final EventChannel _attributionEvent;

  late void Function(Map) _attributionListener;

  Map? _initialAttribution;

  AttributionAPI(this._attributionEvent) {
    _attributionListener = (result) {
      _initialAttribution = result;
    };

    _attributionEvent
        .receiveBroadcastStream("attribution")
        .listen((result) {
          Log.info('[attribution] $result');

          _attributionListener(result);
        });
  }

  void setAttributionListener(void Function(Map) listener) {
    Log.info('set attribution listener');

    _initialAttribution?.let((it) {
      listener(it);
      _initialAttribution = null;
    });

    this._attributionListener = listener;
  }
}
